## fastcdr 1.1.0

=== CMakeLists.txt ===
# Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###############################################################################
# CMake build rules for FastCDR                                               #
###############################################################################
cmake_minimum_required(VERSION 3.16.3)

set(IS_TOP_LEVEL TRUE)
if(PROJECT_SOURCE_DIR)
    set(IS_TOP_LEVEL FALSE)
endif()

# Set CMAKE_BUILD_TYPE to Release by default.
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to 'Release' as none was specified.")
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

###############################################################################
# Version information                                                         #
###############################################################################

#If not set, copy over product version from configure.ac
file(STRINGS
    configure.ac
    LIB_MAJOR_VERSION_TMP
    REGEX "^m4_define\\(\\[?version_major\\]?, *\\[?[0-9]+\\]?\\)"
    )
file(STRINGS
    configure.ac
    LIB_MINOR_VERSION_TMP
    REGEX "^m4_define\\(\\[?version_minor\\]?, *\\[?[0-9]+\\]?\\)"
    )
file(STRINGS
    configure.ac
    LIB_PATCH_VERSION_TMP
    REGEX "^m4_define\\(\\[?version_micro\\]?, *\\[?[0-9]+\\]?\\)"
    )

string(REGEX REPLACE "m4_define\\(\\[?version_major\\]?, *\\[?([0-9]+)\\]?\\)"
    "\\1"
    LIB_MAJOR_VERSION
    ${LIB_MAJOR_VERSION_TMP}
    )
string(REGEX REPLACE "m4_define\\(\\[?version_minor\\]?, *\\[?([0-9]+)\\]?\\)"
    "\\1"
    LIB_MINOR_VERSION
    ${LIB_MINOR_VERSION_TMP}
    )
string(REGEX REPLACE "m4_define\\(\\[?version_micro\\]?, *\\[?([0-9]+)\\]?\\)"
    "\\1"
    LIB_PATCH_VERSION
    ${LIB_PATCH_VERSION_TMP}
    )

set(LIB_VERSION_STR "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_PATCH_VERSION}")

###############################################################################
# Project                                                                     #
###############################################################################
if(CMAKE_VERSION VERSION_LESS 3.0)
    project(fastcdr CXX)
    set(PROJECT_VERSION_MAJOR "${LIB_MAJOR_VERSION}")
    set(PROJECT_VERSION_MINOR "${LIB_MINOR_VERSION}")
    set(PROJECT_VERSION_PATCH "${LIB_PATCH_VERSION}")
    set(PROJECT_VERSION "${LIB_VERSION_STR}")
else()
    cmake_policy(SET CMP0048 NEW)
    project(fastcdr VERSION "${LIB_VERSION_STR}" LANGUAGES CXX)
endif()

set(PROJECT_NAME_STYLED "FastCDR")
set(PROJECT_NAME_LARGE "Fast CDR")
string(TOUPPER "${PROJECT_NAME}" PROJECT_NAME_UPPER)
set(${PROJECT_NAME}_DESCRIPTION_SUMMARY "C++ library for serialize using CDR serialization")
set(${PROJECT_NAME}_DESCRIPTION "eProsima ${PROJECT_NAME_LARGE} library provides two serialization mechanisms. One is the standard CDR serialization mechanism, while the other is a faster implementation that modifies the standard.")

message(STATUS "Configuring ${PROJECT_NAME_LARGE}")
message(STATUS "Version: ${PROJECT_VERSION}")
message(STATUS "To change the version modify the file configure.ac")

###############################################################################
# Generation of windows installers.
###############################################################################
option(EPROSIMA_INSTALLER "Activate the creation of a build to create windows installers" OFF)

###############################################################################
# CCache on Windows on CI
###############################################################################
if (MSVC AND CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
    foreach(config DEBUG RELWITHDEBINFO)
        foreach(lang C CXX)
            set(flags_var "CMAKE_${lang}_FLAGS_${config}")
            string(REPLACE "/Zi" "/Z7" ${flags_var} "${${flags_var}}")
            set(${flags_var} "${${flags_var}}")
        endforeach()
    endforeach()
endif()

###############################################################################
# GCC colors if using CCache
###############################################################################
if("${CMAKE_CXX_COMPILER_LAUNCHER}" STREQUAL "ccache" AND
        CMAKE_COMPILER_IS_GNUCXX AND
        CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4,8)
    add_compile_options(-fdiagnostics-color=always)
endif()

###############################################################################
# Default shared libraries
###############################################################################
# Global flag to cause add_library() to create shared libraries if on.
# If set to true, this will cause all libraries to be built shared
# unless the library was explicitly added as a static library.
option(BUILD_SHARED_LIBS "Create shared libraries by default" ON)

###############################################################################
# Load external eProsima projects.
###############################################################################

option(EPROSIMA_BUILD "Activate internal building" OFF)

if(EPROSIMA_INSTALLER)
    set(EPROSIMA_BUILD ON)
endif()

###############################################################################
# Test system configuration
###############################################################################
include(${PROJECT_SOURCE_DIR}/cmake/common/check_configuration.cmake)

set(FORCE_CXX "11" CACHE STRING "C++ standard fulfillment selection")
check_stdcxx(${FORCE_CXX})

check_endianness()
check_type_sizes()

###############################################################################
# Check MSVC architecture
###############################################################################
if(MSVC OR MSVC_IDE)
    check_msvc_arch()
endif()

###############################################################################
# Installation paths
###############################################################################
option(APPEND_PROJECT_NAME_TO_INCLUDEDIR
  "When ON headers are installed to a path ending with a folder called \
  ${PROJECT_NAME}. This avoids include directory search order issues when \
  overriding this package from a merged catkin, ament, or colcon workspace."
  OFF)

set(BIN_INSTALL_DIR bin/ CACHE PATH "Installation directory for binaries")
set(_include_dir "include/")
if(APPEND_PROJECT_NAME_TO_INCLUDEDIR)
  string(APPEND _include_dir "${PROJECT_NAME}/")
endif()
set(INCLUDE_INSTALL_DIR "${_include_dir}" CACHE PATH "Installation directory for C++ headers")
unset(_include_dir)
set(LIB_INSTALL_DIR lib${LIB_SUFFIX}/ CACHE PATH "Installation directory for libraries")
set(DATA_INSTALL_DIR share/ CACHE PATH "Installation directory for data")
if(WIN32)
    set(DOC_DIR "doc")
else()
    set(DOC_DIR "${DATA_INSTALL_DIR}/doc")
endif()
set(DOC_INSTALL_DIR ${DOC_DIR} CACHE PATH "Installation directory for documentation")
if(WIN32 AND EPROSIMA_INSTALLER AND IS_TOP_LEVEL)
    set(LICENSE_INSTALL_DIR . CACHE PATH "Installation directory for licenses")
else()
    set(LICENSE_INSTALL_DIR ${DATA_INSTALL_DIR}/${PROJECT_NAME} CACHE PATH "Installation directory for licenses")
endif()

###############################################################################
# Compile library.
###############################################################################
add_subdirectory(src/cpp)

###############################################################################
# Testing options
###############################################################################
option(EPROSIMA_BUILD_TESTS "Activate the building and execution unit tests and integral tests" OFF)

if(EPROSIMA_BUILD AND NOT EPROSIMA_INSTALLER AND NOT EPROSIMA_INSTALLER_MINION)
    set(EPROSIMA_BUILD_TESTS ON)
endif()

###############################################################################
# Testing
###############################################################################
if(EPROSIMA_BUILD_TESTS AND IS_TOP_LEVEL AND NOT EPROSIMA_INSTALLER)
    enable_testing()
    include(CTest)

    add_subdirectory(test)
endif()

###############################################################################
# Documentation
###############################################################################
# Add an option to toggle the generation of the API documentation.
option(BUILD_DOCUMENTATION "Use doxygen to create product documentation" OFF)
option(CHECK_DOCUMENTATION "Use doxygen to check code documentation" OFF)

if(EPROSIMA_INSTALLER)
    set(BUILD_DOCUMENTATION ON)
    set(DOXYGEN_SHOULD_SKIP_THIS_PUBLIC "DOXYGEN_SHOULD_SKIP_THIS_PUBLIC")
endif()

if(CHECK_DOCUMENTATION)
    set(BUILD_DOCUMENTATION ON)
endif()

if(BUILD_DOCUMENTATION)
    find_package(Doxygen)
    if(NOT DOXYGEN_FOUND)
        message(FATAL_ERROR "doxygen is needed to build the documentation. Please install it correctly")
    endif()
    if(UNIX)
        find_program(DOXYFILE_MAKE make)
        if(DOXYFILE_MAKE)
            message(STATUS "Found Make: ${DOXYFILE_MAKE}")
        else()
            message(FATAL_ERROR "make is needed to build the documentation. Please install it correctly")
        endif()
    elseif(WIN32)
        set(DOXYFILE_MAKE make.bat)
    endif()

    if(NOT CHECK_DOCUMENTATION)
        find_program(WGET_EXE wget)
        if(WGET_EXE)
            message(STATUS "Found WGet: ${WGET_EXE}")
        else()
            message(FATAL_ERROR "wget is needed to build the documentation. Please install it correctly")
        endif()
        find_program(UNZIP_EXE unzip)
        if(UNZIP_EXE)
            message(STATUS "Found Unzip: ${UNZIP_EXE}")
        else()
            message(FATAL_ERROR "unzip is needed to build the documentation. Please install it correctly")
        endif()
    endif()

    # Target to create documentation directories
    add_custom_target(docdirs
        COMMAND ${CMAKE_COMMAND} -E make_directory ${PROJECT_BINARY_DIR}/doc
        COMMENT "Creating documentation directory" VERBATIM)

    ### Doxygen ########################3
    if(CHECK_DOCUMENTATION)
        set(USE_DOT NO)
    else()
        set(USE_DOT YES)
    endif()
    # Configure the template doxyfile for or specific project
    configure_file(doxyfile.in ${PROJECT_BINARY_DIR}/doxyfile @ONLY IMMEDIATE)
    # Add custom target to run doxygen when ever the project is build
    add_custom_target(doxygen
        COMMAND "${DOXYGEN_EXECUTABLE}" "${PROJECT_BINARY_DIR}/doxyfile"
        SOURCES "${PROJECT_BINARY_DIR}/doxyfile"
        COMMENT "Generating API documentation with doxygen" VERBATIM)

    add_dependencies(doxygen docdirs)

    ### README html ########################

    if(WIN32)
        set(README_LOCATION "${PROJECT_BINARY_DIR}/")
        set(README_LOCATION_PREFFIX "doc/")
        set(README_INSTALL_LOCATION ".")
    else()
        set(README_LOCATION "${PROJECT_BINARY_DIR}/doc/")
        set(README_INSTALL_LOCATION "${DOC_INSTALL_DIR}")
    endif()

    configure_file(doc/README.html.in ${README_LOCATION}/README.html @ONLY IMMEDIATE)

    ### ReadTheDocs ########################
#    if(NOT CHECK_DOCUMENTATION)
#        add_custom_target(readthedocs

=== test/CMakeLists.txt ===
# Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

find_package(GTest CONFIG REQUIRED)
include(${PROJECT_SOURCE_DIR}/cmake/common/gtest.cmake)

###############################################################################
# Unit tests
###############################################################################
set(UNITTESTS_SOURCE SimpleTest.cpp ResizeTest.cpp)
add_executable(UnitTests ${UNITTESTS_SOURCE})
set_common_compile_options(UnitTests)
target_link_libraries(UnitTests fastcdr GTest::gtest_main)
add_gtest(UnitTests SOURCES ${UNITTESTS_SOURCE})

###############################################################################
# CMake modules tests
###############################################################################

set(build_dir "${fastcdr_BINARY_DIR}/test/force_cxx")
set(module_dir "${fastcdr_SOURCE_DIR}/cmake/common")
set(script "${CMAKE_CURRENT_LIST_DIR}/cmake/build.cmake")

# The C++ sources use fold expressions which were introduced in C++17 

# Tests that C++17 sources can be built enforcing C++17 through CMake
add_test(NAME cmake.force_standard.positive.builtin
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=17 -DTEST_FALLBACK=OFF
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# Tests that C++17 sources can be built enforcing C++17 manually
add_test(NAME cmake.force_standard.positive.manual
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=17 -DTEST_FALLBACK=ON
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# Tests that C++17 sources cannot be built enforcing C++14 through CMake
add_test(NAME cmake.force_standard.negative.builtin
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=14 -DTEST_FALLBACK=OFF
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# Tests that C++17 sources cannot be built enforcing C++14 manually
add_test(NAME cmake.force_standard.negative.manual
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=14 -DTEST_FALLBACK=ON
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# set the negative testing
set_tests_properties(
    cmake.force_standard.negative.builtin
    cmake.force_standard.negative.manual
    PROPERTIES WILL_FAIL TRUE)

=== src/cpp/CMakeLists.txt ===
# Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(${PROJECT_SOURCE_DIR}/cmake/dev/set_sources.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/dev/generate_msvc_libraries.cmake)

# Set source files
set_sources(
    Cdr.cpp
    FastCdr.cpp
    FastBuffer.cpp
    exceptions/Exception.cpp
    exceptions/NotEnoughMemoryException.cpp
    exceptions/BadParamException.cpp
    FastCdr.rc
)

configure_file(${PROJECT_SOURCE_DIR}/include/${PROJECT_NAME}/config.h.in
    ${PROJECT_BINARY_DIR}/include/${PROJECT_NAME}/config.h)

if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
endif()

# Create libraries
if(MSVC OR MSVC_IDE AND EPROSIMA_INSTALLER AND IS_TOP_LEVEL)
    generate_msvc_libraries(i86Win32VS2013)
    generate_msvc_libraries(x64Win64VS2013)
    generate_msvc_libraries(i86Win32VS2015)
    generate_msvc_libraries(x64Win64VS2015)
    generate_msvc_libraries(i86Win32VS2017)
    generate_msvc_libraries(x64Win64VS2017)
elseif(NOT EPROSIMA_INSTALLER)
    # Create library
    add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SOURCES})
    set_common_compile_options(${PROJECT_NAME})
    set_target_properties(${PROJECT_NAME} PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        )

    target_compile_definitions(${PROJECT_NAME}
        PRIVATE
        ${PROJECT_NAME_UPPER}_SOURCE
	INTERFACE
        $<$<BOOL:${WIN32}>:${PROJECT_NAME_UPPER}_NO_LIB>
        PUBLIC
	$<$<STREQUAL:$<TARGET_PROPERTY:${PROJECT_NAME},TYPE>,SHARED_LIBRARY>:${PROJECT_NAME_UPPER}_DYN_LINK>
        )

    # Define public headers
    target_include_directories(${PROJECT_NAME} PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include> $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
        $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
        )

    if(MSVC OR MSVC_IDE)
        set_target_properties(${PROJECT_NAME} PROPERTIES
            RELEASE_POSTFIX -${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            RELWITHDEBINFO_POSTFIX -${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            DEBUG_POSTFIX d-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
	    )

        get_target_property(TARGET_TYPE ${PROJECT_NAME} TYPE)
        if(TARGET_TYPE STREQUAL "SHARED_LIBRARY")
            # Export symbols in DLL library
            set_target_properties(${PROJECT_NAME} PROPERTIES
                PDB_NAME_DEBUG ${PROJECT_NAME}d-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
                PDB_OUTPUT_DIRECTORY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/symbols"
            )
        else()
            # Rename the library to have a "lib" before.
            set_target_properties(${PROJECT_NAME} PROPERTIES
                OUTPUT_NAME lib${PROJECT_NAME}
                COMPILE_PDB_NAME_DEBUG lib${PROJECT_NAME}d-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
                COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/symbols"
            )
        endif()

        # For installing purpose.
        if(EPROSIMA_INSTALLER_MINION)
            set(MSVCARCH_EXTENSION "_${MSVC_ARCH}")
            set(MSVCARCH_DIR_EXTENSION "/${MSVC_ARCH}")
            set(MSVCARCH_DIR_EXTENSION_EXT "/${MSVC_ARCH}")
            if(NOT TARGET_TYPE STREQUAL "SHARED_LIBRARY")
                set(MSVCARCH_DIR_EXTENSION_EXT "${MSVCARCH_DIR_EXTENSION_EXT}_static")
            endif()
        endif()
    endif()
endif()

###############################################################################
# Packaging
###############################################################################

# Install public headers
set_public_headers_directory(${PROJECT_SOURCE_DIR}/include ${PROJECT_NAME}
    DESTINATION ${INCLUDE_INSTALL_DIR}
    COMPONENT headers
    )

# Install config.h header
set_public_header(${PROJECT_BINARY_DIR}/include ${PROJECT_NAME} config.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}
    COMPONENT headers
    )

set(CPACK_COMPONENT_HEADERS_DISPLAY_NAME "C++ Headers" PARENT_SCOPE)
set(CPACK_COMPONENT_HEADERS_DESCRIPTION "eProsima ${PROJECT_NAME_LARGE} C++ Headers" PARENT_SCOPE)

# Install sources
if(UNIX AND EPROSIMA_INSTALLER)
    install(DIRECTORY ${PROJECT_SOURCE_DIR}/src/cpp
        DESTINATION src
        COMPONENT sources
        FILES_MATCHING
        PATTERN "*.c"
        PATTERN "*.cpp"
        PATTERN "*.h"
        PATTERN "*.hpp"
        )

    install(DIRECTORY ${PROJECT_BINARY_DIR}/autotools/
        DESTINATION .
        USE_SOURCE_PERMISSIONS
        OPTIONAL
        COMPONENT sources
        )
endif()

# Install libraries

if(MSVC OR MSVC_IDE AND EPROSIMA_INSTALLER)
    if(IS_TOP_LEVEL)
        install_msvc_libraries(i86Win32VS2013)
        install_msvc_libraries(x64Win64VS2013)
        install_msvc_libraries(i86Win32VS2015)
        install_msvc_libraries(x64Win64VS2015)
        install_msvc_libraries(i86Win32VS2017)
        install_msvc_libraries(x64Win64VS2017)
    endif()

    install(FILES ${PROJECT_SOURCE_DIR}/cmake/packaging/windows/${PROJECT_NAME}-config.cmake
        DESTINATION ${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME}${MSVCARCH_DIR_EXTENSION_EXT}
        COMPONENT cmake
        )
elseif(NOT EPROSIMA_INSTALLER)

    install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}-targets
        RUNTIME DESTINATION ${BIN_INSTALL_DIR}${MSVCARCH_DIR_EXTENSION}
        LIBRARY DESTINATION ${LIB_INSTALL_DIR}${MSVCARCH_DIR_EXTENSION}
        ARCHIVE DESTINATION ${LIB_INSTALL_DIR}${MSVCARCH_DIR_EXTENSION}
        COMPONENT libraries${MSVCARCH_EXTENSION}
        )

    # Generate different target names depending on linking
    get_target_property(TARGET_TYPE ${PROJECT_NAME} TYPE)
    if(TARGET_TYPE STREQUAL "SHARED_LIBRARY")
         set(FASTCDR_LINKING shared)
    else()
         set(FASTCDR_LINKING static)
    endif()

    if(INSTALLER_PLATFORM)
        set(INSTALL_DESTINATION_PATH ${DATA_INSTALL_DIR}/${PROJECT_NAME}-${INSTALLER_PLATFORM}/cmake)
    else()
        set(INSTALL_DESTINATION_PATH ${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME}${MSVCARCH_DIR_EXTENSION_EXT})
    endif()

    install(EXPORT ${PROJECT_NAME}-targets
        DESTINATION ${INSTALL_DESTINATION_PATH}
	FILE ${PROJECT_NAME}-${FASTCDR_LINKING}-targets.cmake
        COMPONENT cmake
        )

    if(MSVC OR MSVC_IDE)
        # first try dll symbols
        get_target_property(PDB_FILE ${PROJECT_NAME} PDB_NAME_DEBUG)
        if(PDB_FILE)
            get_target_property(PDB_DIR ${PROJECT_NAME} PDB_OUTPUT_DIRECTORY_DEBUG)
            set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
        else()
            # fallback to static lib symbols
            get_target_property(PDB_FILE ${PROJECT_NAME} COMPILE_PDB_NAME_DEBUG)
            if(PDB_FILE)
                get_target_property(PDB_DIR ${PROJECT_NAME} COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG)
                set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
            endif()
        endif()

        # install symbols if any
        if(PDB_FILE)
            install(FILES ${PDB_FILE}
                DESTINATION ${LIB_INSTALL_DIR}${MSVCARCH_DIR_EXTENSION}
                COMPONENT symbols
                CONFIGURATIONS Debug
                )
        endif()
    endif()

    ###############################################################################
    # Create CMake package config file
    ###############################################################################
    include(CMakePackageConfigHelpers)

    if(BUILD_SHARED_LIBS)
        set(FASTRTPS_PACKAGE_OPT_BIN_DIR_CONDITION "if(MSVC OR MSVC_IDE)")
    else()
        set(FASTRTPS_PACKAGE_OPT_BIN_DIR_CONDITION "if(0)")
    endif()

    configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/packaging/Config.cmake.in
        ${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config.cmake
	INSTALL_DESTINATION ${INSTALL_DESTINATION_PATH}
        PATH_VARS BIN_INSTALL_DIR INCLUDE_INSTALL_DIR LIB_INSTALL_DIR
        )
    write_basic_package_version_file(${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config-version.cmake
        VERSION ${PROJECT_VERSION}
        COMPATIBILITY SameMajorVersion
        )
    install(FILES ${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config.cmake
        ${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config-version.cmake
        DESTINATION ${INSTALL_DESTINATION_PATH}
        COMPONENT cmake
        )

    if(MSVCARCH_EXTENSION)
        string(TOUPPER "${MSVC_ARCH}" MSVC_ARCH_UPPER)
        set(CPACK_COMPONENT_LIBRARIES_${MSVC_ARCH_UPPER}_DISPLAY_NAME "${MSVC_ARCH}" PARENT_SCOPE)
        set(CPACK_COMPONENT_LIBRARIES_${MSVC_ARCH_UPPER}_DESCRIPTION "eProsima ${PROJECT_NAME_LARGE} libraries for platform ${MSVC_ARCH}" PARENT_SCOPE)
        set(CPACK_COMPONENT_LIBRARIES_${MSVC_ARCH_UPPER}_GROUP "Libraries" PARENT_SCOPE)
        set(CPACK_COMPONENT_GROUP_LIBRARIES_DESCRIPTION "eProsima ${PROJECT_NAME_LARGE} libraries" PARENT_SCOPE)
    else()
        set(CPACK_COMPONENT_LIBRARIES_DISPLAY_NAME "Libraries" PARENT_SCOPE)
        set(CPACK_COMPONENT_LIBRARIES_DESCRIPTION "eProsima ${PROJECT_NAME_LARGE} libraries" PARENT_SCOPE)
    endif()
endif()

=== test/cmake/CMakeLists.txt ===
# Copyright 2022 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###############################################################################
# Auxiliary project for check_configuration.cmake module testing
###############################################################################
cmake_minimum_required(VERSION 3.16.3)

# setup
option(TEST_FALLBACK "Ignore CMake builtin instrospection and use our original fallback" OFF)

# Test preconditions
if(NOT FORCE_CXX)
    message(FATAL_ERROR "The FORCE_CXX variable must specify the C++ standard to follow")
endif()

if(NOT EPROSIMA_MODULE_PATH)
    message(FATAL_ERROR "check_configuration.cmake path must be specified")
endif()

list(APPEND CMAKE_MODULE_PATH "${EPROSIMA_MODULE_PATH}")

project(std_force_test VERSION 1.0.0 LANGUAGES CXX)

include(check_configuration)

if(TEST_FALLBACK)
    check_stdcxx(${FORCE_CXX} "run_fallback_test")
else()
    check_stdcxx(${FORCE_CXX})
endif()

add_executable(std_force_test fold.cpp)

=== debian/changelog ===
fastcdr (1.1.0-1.2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:57:18 +0000

fastcdr (1.1.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Amend 64-bit time_t transition; symbols file said libfastcdr1 still

 -- Julian Andres Klode <jak@debian.org>  Sat, 23 Mar 2024 20:34:54 +0100

fastcdr (1.1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062546

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 03:46:59 +0000

fastcdr (1.1.0-1) unstable; urgency=medium

  * New upstream version 1.1.0
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Wed, 14 Jun 2023 15:01:29 +0200

=== debian/control ===
Source: fastcdr
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake, ninja-build, pkg-kde-tools,
               libgtest-dev <!nocheck>, doxygen <!nodoc>, graphviz <!nodoc>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/eProsima/Fast-CDR
Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git
Vcs-Browser: https://salsa.debian.org/robotics-team/fastcdr

Package: libfastcdr1t64
Provides: ${t64:Provides}
Replaces: libfastcdr1
Breaks: libfastcdr1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fast CDR serialization library for DDS
 eProsima FastCDR is a C++ library that provides serialization and
 deserialization according to the Common Data Representation (CDR) of the Data
 Distribution Service (DDS) standard and is part of the eProsima FastDDS
 implementation.

Package: libfastcdr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfastcdr1t64 (= ${binary:Version}), ${misc:Depends}
Description: Fast CDR serialization library for DDS - development headers
 eProsima FastCDR is a C++ library that provides serialization and
 deserialization according to the Common Data Representation (CDR) of the Data
 Distribution Service (DDS) standard and is part of the eProsima FastDDS
 implementation.
 .
 This package installs the development headers.

Package: libfastcdr-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, ${misc:Depends}
Description: Fast CDR serialization library for DDS - API documentation
 eProsima FastCDR is a C++ library that provides serialization and
 deserialization according to the Common Data Representation (CDR) of the Data
 Distribution Service (DDS) standard and is part of the eProsima FastDDS
 implementation.
 .
 This package installs the API documentation.

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz% \
 https://api.github.com/repos/eProsima/Fast-CDR/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@

## fastcdr 2.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,12 +15,7 @@
 ###############################################################################
 # CMake build rules for FastCDR                                               #
 ###############################################################################
-cmake_minimum_required(VERSION 3.16.3)
-
-set(IS_TOP_LEVEL TRUE)
-if(PROJECT_SOURCE_DIR)
-    set(IS_TOP_LEVEL FALSE)
-endif()
+cmake_minimum_required(VERSION 3.20)
 
 # Set CMAKE_BUILD_TYPE to Release by default.
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
@@ -31,58 +26,16 @@
     set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
 endif()
 
-###############################################################################
-# Version information                                                         #
-###############################################################################
-
-#If not set, copy over product version from configure.ac
-file(STRINGS
-    configure.ac
-    LIB_MAJOR_VERSION_TMP
-    REGEX "^m4_define\\(\\[?version_major\\]?, *\\[?[0-9]+\\]?\\)"
-    )
-file(STRINGS
-    configure.ac
-    LIB_MINOR_VERSION_TMP
-    REGEX "^m4_define\\(\\[?version_minor\\]?, *\\[?[0-9]+\\]?\\)"
-    )
-file(STRINGS
-    configure.ac
-    LIB_PATCH_VERSION_TMP
-    REGEX "^m4_define\\(\\[?version_micro\\]?, *\\[?[0-9]+\\]?\\)"
-    )
-
-string(REGEX REPLACE "m4_define\\(\\[?version_major\\]?, *\\[?([0-9]+)\\]?\\)"
-    "\\1"
-    LIB_MAJOR_VERSION
-    ${LIB_MAJOR_VERSION_TMP}
-    )
-string(REGEX REPLACE "m4_define\\(\\[?version_minor\\]?, *\\[?([0-9]+)\\]?\\)"
-    "\\1"
-    LIB_MINOR_VERSION
-    ${LIB_MINOR_VERSION_TMP}
-    )
-string(REGEX REPLACE "m4_define\\(\\[?version_micro\\]?, *\\[?([0-9]+)\\]?\\)"
-    "\\1"
-    LIB_PATCH_VERSION
-    ${LIB_PATCH_VERSION_TMP}
-    )
-
-set(LIB_VERSION_STR "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_PATCH_VERSION}")
+# Set BUILD_TESTING to OFF by default.
+if(NOT BUILD_TESTING)
+    message(STATUS "Tests not compiled by default")
+    set(BUILD_TESTING OFF CACHE BOOL "Enable testing" FORCE)
+endif()
 
 ###############################################################################
 # Project                                                                     #
 ###############################################################################
-if(CMAKE_VERSION VERSION_LESS 3.0)
-    project(fastcdr CXX)
-    set(PROJECT_VERSION_MAJOR "${LIB_MAJOR_VERSION}")
-    set(PROJECT_VERSION_MINOR "${LIB_MINOR_VERSION}")
-    set(PROJECT_VERSION_PATCH "${LIB_PATCH_VERSION}")
-    set(PROJECT_VERSION "${LIB_VERSION_STR}")
-else()
-    cmake_policy(SET CMP0048 NEW)
-    project(fastcdr VERSION "${LIB_VERSION_STR}" LANGUAGES CXX)
-endif()
+project(fastcdr VERSION 2.2.2 LANGUAGES CXX)
 
 set(PROJECT_NAME_STYLED "FastCDR")
 set(PROJECT_NAME_LARGE "Fast CDR")
@@ -92,12 +45,6 @@
 
 message(STATUS "Configuring ${PROJECT_NAME_LARGE}")
 message(STATUS "Version: ${PROJECT_VERSION}")
-message(STATUS "To change the version modify the file configure.ac")
-
-###############################################################################
-# Generation of windows installers.
-###############################################################################
-option(EPROSIMA_INSTALLER "Activate the creation of a build to create windows installers" OFF)
 
 ###############################################################################
 # CCache on Windows on CI
@@ -130,16 +77,6 @@
 option(BUILD_SHARED_LIBS "Create shared libraries by default" ON)
 
 ###############################################################################
-# Load external eProsima projects.
-###############################################################################
-
-option(EPROSIMA_BUILD "Activate internal building" OFF)
-
-if(EPROSIMA_INSTALLER)
-    set(EPROSIMA_BUILD ON)
-endif()
-
-###############################################################################
 # Test system configuration
 ###############################################################################
 include(${PROJECT_SOURCE_DIR}/cmake/common/check_configuration.cmake)
@@ -181,11 +118,7 @@
     set(DOC_DIR "${DATA_INSTALL_DIR}/doc")
 endif()
 set(DOC_INSTALL_DIR ${DOC_DIR} CACHE PATH "Installation directory for documentation")
-if(WIN32 AND EPROSIMA_INSTALLER AND IS_TOP_LEVEL)
-    set(LICENSE_INSTALL_DIR . CACHE PATH "Installation directory for licenses")
-else()
-    set(LICENSE_INSTALL_DIR ${DATA_INSTALL_DIR}/${PROJECT_NAME} CACHE PATH "Installation directory for licenses")
-endif()
+set(LICENSE_INSTALL_DIR ${DATA_INSTALL_DIR}/${PROJECT_NAME} CACHE PATH "Installation directory for licenses")
 
 ###############################################################################
 # Compile library.
@@ -193,22 +126,17 @@
 add_subdirectory(src/cpp)
 
 ###############################################################################
-# Testing options
-###############################################################################
-option(EPROSIMA_BUILD_TESTS "Activate the building and execution unit tests and integral tests" OFF)
-
-if(EPROSIMA_BUILD AND NOT EPROSIMA_INSTALLER AND NOT EPROSIMA_INSTALLER_MINION)
-    set(EPROSIMA_BUILD_TESTS ON)
-endif()
-
-###############################################################################
 # Testing
 ###############################################################################
-if(EPROSIMA_BUILD_TESTS AND IS_TOP_LEVEL AND NOT EPROSIMA_INSTALLER)
-    enable_testing()
-    include(CTest)
-
-    add_subdirectory(test)
+enable_testing()
+include(CTest)
+
+if (BUILD_TESTING)
+    if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.22)
+        add_subdirectory(test)
+    else()
+        message(INFO "Tests are disabled because the version of CMake is less than 3.22")
+    endif()
 endif()
 
 ###############################################################################
@@ -217,11 +145,7 @@
 # Add an option to toggle the generation of the API documentation.
 option(BUILD_DOCUMENTATION "Use doxygen to create product documentation" OFF)
 option(CHECK_DOCUMENTATION "Use doxygen to check code documentation" OFF)
-
-if(EPROSIMA_INSTALLER)
-    set(BUILD_DOCUMENTATION ON)
-    set(DOXYGEN_SHOULD_SKIP_THIS_PUBLIC "DOXYGEN_SHOULD_SKIP_THIS_PUBLIC")
-endif()
+option(GENERATE_PDF_DOC "Use doxygen to generate API Reference PDF" OFF)
 
 if(CHECK_DOCUMENTATION)
     set(BUILD_DOCUMENTATION ON)
@@ -269,6 +193,11 @@
     else()
         set(USE_DOT YES)
     endif()
+    if(GENERATE_PDF_DOC)
+        set(GENERATE_LATEX YES)
+    else()
+        set(GENERATE_LATEX NO)
+    endif()
     # Configure the template doxyfile for or specific project
     configure_file(doxyfile.in ${PROJECT_BINARY_DIR}/doxyfile @ONLY IMMEDIATE)
     # Add custom target to run doxygen when ever the project is build
@@ -279,6 +208,15 @@
 
     add_dependencies(doxygen docdirs)
 
+    if(GENERATE_PDF_DOC)
+        add_custom_target(make_pdf ALL
+            COMMAND "make" "pdf"
+            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/doxygen/latex
+            COMMENT "Generating API reference PDF" VERBATIM)
+
+        add_dependencies(make_pdf doxygen)
+    endif()
+
     ### README html ########################
 
     if(WIN32)
@@ -292,6 +230,39 @@
 
     configure_file(doc/README.html.in ${README_LOCATION}/README.html @ONLY IMMEDIATE)
 
-    ### ReadTheDocs ########################
-#    if(NOT CHECK_DOCUMENTATION)
-#        add_custom_target(readthedocs
+    add_custom_target(doc ALL
+        COMMENT "Generated project documentation" VERBATIM)
+
+    add_dependencies(doc doxygen)
+endif()
+
+
+###############################################################################
+# Packaging
+###############################################################################
+# Install licenses
+install(FILES ${PROJECT_SOURCE_DIR}/LICENSE
+    DESTINATION ${LICENSE_INSTALL_DIR}
+    COMPONENT licenses
+    )
+
+if(BUILD_DOCUMENTATION)
+
+    # Instalation of doxygen files
+    install(DIRECTORY ${PROJECT_BINARY_DIR}/doc/api_reference
+        DESTINATION ${DOC_INSTALL_DIR}
+        COMPONENT documentation
+        )
+
+    install(FILES "${README_LOCATION}/README.html"
+        DESTINATION ${README_INSTALL_LOCATION}
+        COMPONENT documentation
+        )
+
+    if(GENERATE_PDF_DOC)
+        install(FILES "${PROJECT_BINARY_DIR}/doxygen/latex/refman.pdf"
+        DESTINATION ${DOC_INSTALL_DIR}
+        RENAME fastcdr-${PROJECT_VERSION}-api-reference.pdf
+        COMPONENT documentation)
+    endif()
+endif()

=== test/xcdr/CMakeLists.txt ===
# Copyright 2023 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###############################################################################
# Unit tests for XCDR extensions
###############################################################################
set(XCDR_TEST_SOURCE
    appendable.cpp
    basic_types.cpp
    external.cpp
    mutable.cpp
    optional.cpp
    xcdrv1.cpp
    xcdrv2.cpp
    )
add_executable(xcdr_tests ${XCDR_TEST_SOURCE})
set_common_compile_options(xcdr_tests)
target_link_libraries(xcdr_tests fastcdr GTest::gtest_main)
gtest_discover_tests(xcdr_tests)

=== debian/changelog ===
fastcdr (2.2.2-1) unstable; urgency=medium

  * New upstream version 2.2.2
  * Refresh patch (no functional change)

 -- Timo Röhling <roehling@debian.org>  Thu, 27 Jun 2024 13:26:02 +0200

fastcdr (2.2.1-3) unstable; urgency=medium

  * Upload to unstable.
  * Drop .0 patch version from .symbols

 -- Timo Röhling <roehling@debian.org>  Wed, 17 Apr 2024 22:34:04 +0200

fastcdr (2.2.1-2) experimental; urgency=medium

  * Re-enable test suite
  * Fix autopkgtest

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Apr 2024 10:35:00 +0200

fastcdr (2.2.1-1) experimental; urgency=medium

  * New upstream version 2.2.1
  * Refresh patches (no functional changes)
  * Bump SONAME to 2
  * Bump Standards-Version to 4.7.0
  * Reformat d/control
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Mon, 15 Apr 2024 16:26:26 +0200

## fastcdr 2.2.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ###############################################################################
 # Project                                                                     #
 ###############################################################################
-project(fastcdr VERSION 2.2.2 LANGUAGES CXX)
+project(fastcdr VERSION 2.2.5 LANGUAGES CXX)
 
 set(PROJECT_NAME_STYLED "FastCDR")
 set(PROJECT_NAME_LARGE "Fast CDR")

=== debian/changelog ===
fastcdr (2.2.5-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 2.2.5
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Mon, 14 Oct 2024 20:07:16 +0200

fastcdr (2.2.4-1) unstable; urgency=medium

  * New upstream version 2.2.4
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 10 Sep 2024 13:37:21 +0200

fastcdr (2.2.3-1) unstable; urgency=medium

  * New upstream version 2.2.3
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Aug 2024 11:42:27 +0200

=== debian/control ===
Source: fastcdr
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 cmake,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libgtest-dev <!nocheck>,
 ninja-build,
 pkg-kde-tools,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/eProsima/Fast-CDR
Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git
Vcs-Browser: https://salsa.debian.org/robotics-team/fastcdr
Description: Fast CDR serialization library for DDS
 eProsima FastCDR is a C++ library that provides serialization and
 deserialization according to the Common Data Representation (CDR) of the Data
 Distribution Service (DDS) standard and is part of the eProsima FastDDS
 implementation.

Package: libfastcdr2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: libfastcdr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libfastcdr2 (= ${binary:Version}),
Description: ${source:Synopsis} - development headers
 ${source:Extended-Description}
 .
 This package installs the development headers.

Package: libfastcdr-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libjs-jquery,
Description: ${source:Synopsis} - API documentation
 ${source:Extended-Description}
 .
 This package installs the API documentation.

=== debian/tests/control ===
Tests: run-test-suite
Depends:
 cmake,
 g++ | c++-compiler,
 libfastcdr-dev,
 libgtest-dev,
Restrictions: allow-stderr

## fastcdr 2.2.6%2Breally2.2.5

=== debian/watch ===
version=4
opts=\
 filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
 searchmode=plain \
 https://api.github.com/repos/eProsima/Fast-CDR/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
